from functools import reduce
from itertools import combinations_with_replacement as cwr
from operator import mul


def mnoj(n: int) -> list[int]:
    n1, mnojs = n, []
    for i in range(2, n + 1):
        if not n1 % i:
            n1 //= i
            if all(i % j for j in mnojs):
                mnojs.append(i)
            if n1 == 1:
                break
    if (mnojmul := reduce(mul, mnojs)) != n:
        mnojs += mnoj(n // mnojmul)
    return mnojs


def allperms(seq) -> set:
    tmp = {(*cwr(seq, i),) for i in range(1, len(seq) + 1)}
    res = set()
    for i in tmp:
        res |= {*i}
    return res


def validmn(n: int) -> set:
    return {m for i in allperms(mnoj(n)) if not n % (m := reduce(mul, i))}


ns = [int(input()) for _ in range(int(input()))]
fib, a, b = set(), 1, 2
while b <= max(ns):
    fib.add(b)
    a, b = b, a + b
for n in ns:
    mncol = [{*i} for i in allperms(validmn(n)) if (m := reduce(mul, i)) == n]
    print(len([i for i in mncol if not i - fib]))
