from itertools import permutations as pms
from functools import cache


@cache
def groups(string) -> set[tuple[str, int]]:
    combs = [*zip(string, string[1:])]
    return {(comb, combs.count(comb)) for comb in {*combs}}


G = input()
for s in [input() for _ in range(int(input()))]:
    combs = groups(s)
    print(sum(1 for str_ in {*pms(''.join(''.join(i) * j for i, j in combs), len(s))} if groups(str_) == combs))
